//+------------------------------------------------------------------+
//|                                                 PivotProfits.mq4 |
//|                                                          Kalenzo |
//|                                          http://www.fxservice.eu |
//+------------------------------------------------------------------+
#property copyright "Kalenzo"
#property link      "http://www.fxservice.eu"
#include <stdlib.mqh>

extern int 	Magic             = 123456,	
			   StopLoss          = 25,
			   TakeProfit        = 30,
			   Slippage          = 1;
string Version = "PivotProfits";

extern double FirstClose = 0.3,
              SecondClose = 0.2;
              //third close will be closing all
              //means that total order lot size should be 0.6 lot
double        stoplosslevel = 0,
              takeprofitlevel = 0;
bool isProgramFinished = false;
bool initialized = false;
int numbeOfCloses = 0;              
double r1 = 0, r2 = 0, r3 = 0, r4 = 0, p = 0, s1 = 0, s2 = 0, s3 = 0, s4 = 0;              
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
    
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   if(isProgramFinished)
   {
      Comment("PivotProfits EA finished it\'s job");
      return;
   }
   
  // if(!orderExists())openOrder(OP_SELL, 0,0);

   initializeLevels();
   setStopLoss();
   
   if(orderExists() && !initialized)
   {
      initTPSL();
      
      if(stoplosslevel!=0 && takeprofitlevel!=0) initialized = true;
   }
      
   if(stoplosslevel==0 || takeprofitlevel==0)
   {
      Alert("CANNOT READ SL/TP LEVELS, ATTACH LNX PIVOT INDICATOR ");
      return;
   }
    

   int total = OrdersTotal();
   for(int cnt = 0; cnt <= total; cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber() == Magic) 
      {
         if(OrderType() == OP_BUY)
         {
            
            //CHECK EXIT WITH STOP LOSS
            if(Ask<stoplosslevel)
            {
                closeOrder(OrderTicket(),1000);
                isProgramFinished = true;
                Print("STOP");
            }
         
            //CHECK EXIT WITH TAKE PROFIT
            if(Ask > takeprofitlevel)
            {
               //1 close part order
               if(numbeOfCloses == 0) 
               {
                  //first close
                  closeOrder(OrderTicket(),FirstClose);
                  numbeOfCloses = 1;
                  Print("FIRST CLOSE");
               }
               else if(numbeOfCloses == 1)
               {
                  //second close
                  closeOrder(OrderTicket(),SecondClose);
                  numbeOfCloses = 2;
                  Print("SECOND CLOSE");
               }
               else
               {
                  //third close - close all
                  closeOrder(OrderTicket(),1000);
                  isProgramFinished = true;
                  Print("THIRD CLOSE");
               }
               
               //2 set new tp level
               if(Ask > p && Ask < r1 && takeprofitlevel !=0 && takeprofitlevel < r1)
               {
                  takeprofitlevel = r1;
               }
               else if(Ask > r1 && Ask < r2 && takeprofitlevel !=0 && takeprofitlevel < r2)
               {
                  takeprofitlevel = r2;
               }
               else if(Ask > r2 && Ask < r3 && takeprofitlevel !=0 && takeprofitlevel < r3)
               {
                  takeprofitlevel = r3;
               }
               else if(Ask < p && Ask > s1 && takeprofitlevel !=0 && takeprofitlevel < p)
               {
                  takeprofitlevel = p;
               }
               else if(Ask < s1 && Ask > s2 && takeprofitlevel !=0 && takeprofitlevel < s1)
               {
                  takeprofitlevel = s1;
               }
               else if(Ask < s2 && Ask > s3 && takeprofitlevel !=0 && takeprofitlevel < s2)
               {
                  takeprofitlevel = s2;
               }   
            }
            
         }
         else if(OrderType() == OP_SELL)
         {
            //CHECK EXIT WITH STOP LOSS
            if(Bid>stoplosslevel)
            {
                closeOrder(OrderTicket(),1000);
                isProgramFinished = true;
                Print("STOP");
            }
         
            //CHECK EXIT WITH TAKE PROFIT
            if(Bid < takeprofitlevel)
            {
               //1 close part order
               if(numbeOfCloses == 0) 
               {
                  //first close
                  closeOrder(OrderTicket(),FirstClose);
                  numbeOfCloses = 1;
                  Print("FIRST CLOSE");
               }
               else if(numbeOfCloses == 1)
               {
                  //second close
                  closeOrder(OrderTicket(),SecondClose);
                  numbeOfCloses = 2;
                  Print("SECOND CLOSE");
               }
               else
               {
                  //third close - close all
                  closeOrder(OrderTicket(),1000);
                  isProgramFinished = true;
                  Print("THIRD CLOSE");
               }
               
               //2 set new tp level
               if(Bid > p && Bid < r1 && takeprofitlevel !=0 && takeprofitlevel > p)
               {
                  takeprofitlevel = p;
               }
               else if(Bid > r1 && Bid < r2 && takeprofitlevel !=0 && takeprofitlevel > r1)
               {
                  takeprofitlevel = r1;
               }
               else if(Bid > r2 && Bid < r3 && takeprofitlevel !=0 && takeprofitlevel > r2)
               {
                  takeprofitlevel = r2;
               }
               else if(Bid < p && Bid > s1 && takeprofitlevel !=0 && takeprofitlevel > s1)
               {
                  takeprofitlevel = s1;
               }
               else if(Bid < s1 && Bid > s2 && takeprofitlevel !=0 && takeprofitlevel > s2)
               {
                  takeprofitlevel = s2;
               }
               else if(Bid < s2 && Bid > s3 && takeprofitlevel !=0 && takeprofitlevel > s3)
               {
                  takeprofitlevel = s3;
               }
            }   
         }
         
         break;
      } 
   } 
   
   
   drawLine("TAKEPROFIT",Time[10], takeprofitlevel, 2, Lime,1);
   drawLine("STOPLOSS",Time[10], stoplosslevel, 2, Magenta,1);
//----
   return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|EXPERT FUNCTIONS                                                  |
//+------------------------------------------------------------------+
double readTLLevel(string name)
{
   while(true)
   {
      int    obj_total=ObjectsTotal();
       
      for(int i=0;i<obj_total;i++)
      {
         if(ObjectName(i) == name)
         {
            return(ObjectGetValueByShift(name, 0));
         }
      }
      Sleep(1000);
   }  
}
//+------------------------------------------------------------------+
void initializeLevels()
{
   r4 = readTLLevel("R4[0]");
   r3 = readTLLevel("R3[0]");
   r2 = readTLLevel("R2[0]");
   r1 = readTLLevel("R1[0]");
   
   p  = readTLLevel("PP[0]"); 
   
   s1 = readTLLevel("S1[0]");
   s2 = readTLLevel("S2[0]");
   s3 = readTLLevel("S3[0]"); 
   s4 = readTLLevel("S4[0]");
 
}
//+------------------------------------------------------------------+
void initTPSL()
{
    int total = OrdersTotal();
    for(int cnt = 0 ;cnt<=total;cnt++)
    {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber() == Magic) 
      {
         double oop = OrderOpenPrice();
         
         if(OrderType() == OP_BUY)
         {
            if(oop > p && oop < r1)
            {
               stoplosslevel = p;
               takeprofitlevel = r1;
            }
            else if(oop > r1 && oop < r2)
            {
               stoplosslevel = r1;
               takeprofitlevel = r2;
            }
            else if(oop > r2 && oop < r3)
            {
               stoplosslevel = r2;
               takeprofitlevel = r3;
            }
            else if(oop < p && oop > s1)
            {
               stoplosslevel = s1;
               takeprofitlevel = p;
            }
            else if(oop < s1 && oop > s2)
            {
               stoplosslevel = s2;
               takeprofitlevel = s1;
            }
            else if(oop < s2 && oop > s3)
            {
               stoplosslevel = s3;
               takeprofitlevel = s2;
            }
         }
         else if(OrderType() == OP_SELL)
         {
            if(oop > p && oop < r1)
            {
               stoplosslevel = r1;
               takeprofitlevel = p;
            }
            else if(oop > r1 && oop < r2)
            {
               stoplosslevel = r2;
               takeprofitlevel = r1;
            }
            else if(oop > r2 && oop < r3)
            {
               stoplosslevel = r3;
               takeprofitlevel = r2;
            }
            else if(oop < p && oop > s1)
            {
               stoplosslevel = p;
               takeprofitlevel = s1;
            }
            else if(oop < s1 && oop > s2)
            {
               stoplosslevel = s1;
               takeprofitlevel = s2;
            }
            else if(oop < s2 && oop > s3)
            {
               stoplosslevel = s2;
               takeprofitlevel = s3;
            }
         }
         
      }
    } 
     
}
//+------------------------------------------------------------------+
void setStopLoss()
{
    int total = OrdersTotal();
    for(int cnt = 0 ;cnt<=total;cnt++)
    {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber() == Magic) 
      {
         double oop = 0;
         
         if(OrderType() == OP_BUY)
         {
            oop = Low[1];
            
            if(oop > p && oop < r1 && stoplosslevel!=0 && stoplosslevel < p)
            {
               stoplosslevel = p;
            }
            else if(oop > r1 && oop < r2 && stoplosslevel!=0 && stoplosslevel < r1)
            {
               stoplosslevel = r1;
            }
            else if(oop > r2 && oop < r3 && stoplosslevel!=0 && stoplosslevel < r2)
            {
               stoplosslevel = r2;
            }
            else if(oop < p && oop > s1 && stoplosslevel!=0 && stoplosslevel < s1)
            {
               stoplosslevel = s1;
            }
            else if(oop < s1 && oop > s2 && stoplosslevel!=0 && stoplosslevel < s2)
            {
               stoplosslevel = s2;
            }
            else if(oop < s2 && oop > s3 && stoplosslevel!=0 && stoplosslevel < s3)
            {
               stoplosslevel = s3;
            }
         }
         else if(OrderType() == OP_SELL)
         {
            oop = High[1];
            if(oop > p && oop < r1  && stoplosslevel!=0 && stoplosslevel > r1)
            {
               stoplosslevel = r1;
            }
            else if(oop > r1 && oop < r2  && stoplosslevel!=0 && stoplosslevel < r2)
            {
               stoplosslevel = r2;
            }
            else if(oop > r2 && oop < r3  && stoplosslevel!=0 && stoplosslevel < r3)
            {
               stoplosslevel = r3;
            }
            else if(oop < p && oop > s1  && stoplosslevel!=0 && stoplosslevel > p)
            {
               stoplosslevel = p;
            }
            else if(oop < s1 && oop > s2  && stoplosslevel!=0 && stoplosslevel > s1)
            {
               stoplosslevel = s1;
            }
            else if(oop < s2 && oop > s3  && stoplosslevel!=0 && stoplosslevel < s2)
            {
               stoplosslevel = s2;
            }
         }
         
      }
    } 
     
}
//+------------------------------------------------------------------+
void drawLine(string name,datetime tfrom, double pfrom , int width, color Col,int type)
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_HLINE, 0, tfrom, pfrom);
            
            if(type == 1) 
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else if(type == 2)
            ObjectSet(name, OBJPROP_STYLE, STYLE_DASHDOT);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,width);
             
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_HLINE, 0, tfrom, pfrom);
            
            if(type == 1) 
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else if(type == 2)
            ObjectSet(name, OBJPROP_STYLE, STYLE_DASHDOT);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,width);
          
         }
}  
//+------------------------------------------------------------------+
bool closeOrder(int ticket,double size)
{
   if(!IsTradeAllowed() )
   return (false);
   
   int MAXRETRIES = 5;
   int retries = 0;
   
   OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES);
   
   double lots = OrderLots();
   if(size > lots)
   {
       isProgramFinished = true;
   }
   else
   {
      lots = size;
   }
    
   int error;
   if(OrderType() == OP_BUY)
   {
      while(!OrderClose(ticket,lots, Bid, Slippage, Red))
      {
      
            error = GetLastError();
            
            if(error>1)
            Print("OrderClose failed with error #",ErrorDescription(error));
            
            Sleep(1000);
            
            RefreshRates();
         
            if(retries >= MAXRETRIES) 
              return(false);
            else
              retries++;
        }

   }
   else
   {
         while(!OrderClose(ticket, lots, Ask, Slippage, Red))
         {
            error = GetLastError();
            
            if(error>1)
            Print("OrderClose failed with error #",ErrorDescription(error));
            
            Sleep(1000);
            
            RefreshRates();
         
            if(retries >= MAXRETRIES) 
              return(false);
            else
              retries++;
        }

   }
   
   return (true);
}  
//+------------------------------------------------------------------+
//| FUNCTIONS TO REMOVE LATER                                        |
//+------------------------------------------------------------------+ 

bool orderExists()
{
    int total = OrdersTotal();
    for(int cnt = 0 ;cnt<=total;cnt++)
    {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber() == Magic) 
      return(true);
    } 
    return(false); 
}
/*
bool openOrder(int type, double sl,double tp, string description = "" )
{
   if(!IsTradeAllowed())
	{
		return (-1);
	}
   
	int error = 0;
	int ticket = 0;
  
 
   	
	if( type == OP_SELL )
	{
		while(true)
		{
		   RefreshRates();
		    
		 	ticket = OrderSend(Symbol(),OP_SELL,1.1,MarketInfo(Symbol(),MODE_BID),Slippage,sl,tp,StringConcatenate(Version," ",description),Magic,0,Pink);
         
			if(ticket<=0)
			{
				error=GetLastError();
            Print("SELL ORDER ERROR:", ErrorDescription(error));
            
            if(!ErrorBlock(error)) break;
            
			}
			else
			{
			   OrderSelect(ticket,SELECT_BY_TICKET);
			   OrderPrint(); 
			   break;
			}
		} 	
   }
   else if( type == OP_BUY )
   {
		
		while(true)
		{
		   RefreshRates();
		   
			ticket = OrderSend(Symbol(),OP_BUY,1.1,MarketInfo(Symbol(),MODE_ASK),Slippage,sl,tp,StringConcatenate(Version," ",description),Magic,0,Lime);
         
			if(ticket<=0)
			{
				error=GetLastError();
            Print("BUY ORDER ERROR:", ErrorDescription(error));
            
            if(!ErrorBlock(error)) break;
            
			}
			else
			{
			   OrderSelect(ticket,SELECT_BY_TICKET);
			   OrderPrint(); 
			   break;
			}
			
		}
   }
    
   return (0);
}
//+------------------------------------------------------------------+
bool ErrorBlock(int error = 0)
{
   
   switch(error)
   {
       case 0: 
       {
         //no error - exit from loop
         Print("NO ERROR");
         return(false);
       }
       case 2:
       {
           Print("System failure. Reboot the computer/check the server");
           return(false);  
       }
       case 3:
       {
           Print("Error of the logic of the EA");
           return(false);  
       }
       case 4:
       {
           Print("Trading server is busy. Wait for 2 minutes.");
           Sleep(120000);
           return(true);   
       }
       case 6:
       { 
           bool connect = false;
           int iteration = 0;
           Print("Disconnect ");
           while((!connect) || (iteration > 60))
           {
               Sleep(10000);
               Print("Connection not restored", iteration*10,"  seconds passed");
               connect = IsConnected();
               if(connect)
               {
                   Print("Connection restored");
               }
               iteration++;
           }
           Print("Connection problems");
           return(false);  
       }
       case 8:
       {
           Print("Frequent requests");
           return(false);  
       }
       case 64:
       {
           Print("Account is blocked!");
           return(false);  
       }
       case 65:
       {
           Print("Wrong account number???");
           return(false);  
       }
       case 128:
       {//????
           Print("Waiting of transaction timed out");
           Sleep(10000);//10 seconds
           RefreshRates();
           return(false);  
       }
       case 129:
       {
           Print("Wrong price");
           RefreshRates();
           return(false);  
       }
       case 130:
       {
           Print("Wrong stop SLEVEL"+MarketInfo(Symbol(),MODE_STOPLEVEL)+" FZLVL "+MarketInfo(Symbol(),MODE_FREEZELEVEL)+" FZLVL "+MarketInfo(Symbol(),MODE_SPREAD));
           RefreshRates();
           return(false);   
       }
       case 131:
       {
           Print("Wrong calculation of trade volume");
           return(false);  
       }
       case 132:
       {
           Print("Market closed");
           return(false);  
       }
       case 134:
       {//NOT ENOUGH CASH?
           Print("Lack of margin for performing operation, margin: "+AccountFreeMargin());
           
           return(false);  
       }
       case 135:
         {
           Print("Prices changed");
           RefreshRates();
           return(true);  
         }
       case 136:
         {
           Print("No price!");
           return(false);  
         }
       case 138:
         {
           Print("Requote again!");
           RefreshRates();
           return(true);  
         }
       case 139:
         {
           Print("The order is in process. Program glitch");
           Sleep(10000);//10 seconds
           return(true);  
         }
       case 141:
         {
           Print("Too many requests");
           Sleep(10000);//10 seconds 
           return(true);  
         }
       case 148:
         {
           Print("Transaction volume too large");
           return(false);  
         }                                          
         default:
         {  
            Print("Unhandeled exception code:",error," stoplevel ",MarketInfo( Symbol(), MODE_STOPLEVEL) ," spread ",MarketInfo( Symbol(), MODE_SPREAD));
            return(false);
         }
     }
   
  }*/